'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _csvParse = require('csv-parse');

var _csvParse2 = _interopRequireDefault(_csvParse);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CSVParser = function () {
  function CSVParser(app) {
    _classCallCheck(this, CSVParser);

    app.get('data-loader').parser('csv', _underscore2.default.partial(this.parse, ',').bind(this));
    app.get('data-loader').parser('tsv', _underscore2.default.partial(this.parse, '\t').bind(this));
  }

  _createClass(CSVParser, [{
    key: 'parse',
    value: function parse(delimiter, contents, opts) {
      var delimiter = opts.delimiter || delimiter;
      return new _bluebird2.default(function (resolve, reject) {
        (0, _csvParse2.default)(contents, { delimiter: delimiter, trim: true }, function (err, data) {
          if (err) {
            reject(err);
            return;
          }
          var header = data.shift();
          var results = _underscore2.default.map(data, function (row) {
            row = _underscore2.default.map(row, function (r) {
              if (_underscore2.default.isString(r)) r = r.trim();return r;
            });
            return _underscore2.default.object(header, row);
          });
          resolve(results);
        });
      });
    }
  }]);

  return CSVParser;
}();

exports.default = CSVParser;